#!/usr/bin/perl -T
# $Id: main.cgi,v 1.51 2021/10/29 05:16:23 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use SocketClient;
use CGI qw(:standard :netscape);
use Sys::Hostname;
use SemaforeFile;

my $hostname = hostname;
my $pwdhost = get_cv('passwds','passwd_server');
my $isadmin = 0;
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    my $uid = login_ok();
    $isadmin = &is_admin();
    if ($uid)
    { 
	$uid = &RFC::Main::passwd_client('pwdstatus',&get_id()) if ($hostname eq $pwdhost);
	print_header("$name main page");
	top_nav_bar_start();
	if ($isadmin)
	{
	    top_nav_bar_button('confmanage.cgi','','','Global configuration','s0');
	    if ($hostname eq $pwdhost || $pwdhost eq 'localhost')
	    {
		top_nav_bar_button('usermanage.cgi','','','User management','s1');
	    }
	    else
	    {
		top_no_button;
	    }
	}
	else
	{
	    if ($hostname eq $pwdhost || $pwdhost eq 'localhost')
	    {
		top_nav_bar_button('task.cgi','','','Manage safty clearances','s3');
	    }
	    else
	    {
		top_no_button;
	    }
	    top_no_button;
	}
	my $acmode = &get_cv('global','access_mode');
	$acmode = 'celltest' unless ($acmode);
	if (&user_auth($acmode,'r'))
	{
	    top_nav_bar_button('search_reports.cgi','','','Search reports','s6');
	}
	else
	{
	    top_no_button();
	}
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	&top_nav_bar_button('util.cgi','','','Utilities','s7');
	if ($hostname eq $pwdhost || $pwdhost eq 'localhost')
	{
	    &top_nav_bar_button('changepwd.cgi','','','Change password','s6');
	}
	else
	{
	    top_no_button();
	}
	&top_nav_bar_button('about.cgi','','','About','s5');
	## Specproc for derect access to labysstem, remoove if no labsystem ####
	## top_no_button();
	if ($pwdhost eq 'localhost')
	{
	    top_no_button();
	}
	else
	{
	    if (CGI::https())
	    {
		&top_nav_bar_button('https://'.$pwdhost.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	    else
	    {
		&top_nav_bar_button('http://'.$pwdhost.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	}
	## End specproc
	&end_top_bar;
        if ($uid =~ /RESET/)
        {
            print center(h2({-class=>'Alert'},"You must change your password!"));
        }
	elsif ($uid =~ /EXPIRE/)
	{
	    print center(h2({-class=>'Alert'},"Your password has expired, Please change password"));
	}
        else
        {
	    &main_page;
	}
	&print_end();
    }
    else 
    {
	&not_auth;
    }
}
    
exit;


sub main_page
{
    my $n = param('name');
    my $p = param('pass');
    print <<END;

<script>

var cred = '&name=$n&pass=$p';

</script>

END
    my $is_cache = 0;
    my $save_cache = 0;
    my %cache = ();
    my $file = '/tmp/RFCcache.txt';
    my $conf = SemaforeFile->new($file);
    $conf->lock_sh();
    if ($conf->exist)
    {
        $is_cache = 1;
        my $mtime = $conf->mtime();
        $is_cache = 0 if ($mtime + 3600 < time);
        $is_cache = 0 if (param('reload'));
    }
    if ($is_cache)
    {
        foreach my $l ($conf->readlines())
        {
            next unless ($l);
            chomp $l;
            my ($k,$d) = split(/\s*\#\s*/,$l);
            $cache{$k} = $d;
        }
    }
    $conf->lock_un();
    print '<center>';
    my $server = `/bin/hostname`;
    $server =~ /([\w\-]+)/;
    $server = $1;
    my @list = ();
    my @listservers = ();
    my $listserver = get_cv('servers','listserver');
    if ($listserver)
    {
        chomp $listserver;
        unless ($is_cache && $cache{'servers'})
        {
	    my $str= &RFC::Main::report_client($listserver,'servers');
	    my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
	    foreach (@l)
	    {
		if (/([\w\.\-]+)/)
		{
		    push @list,$1;
		}
	    }
	    $cache{'servers'} = join(',',@list);
	    $save_cache = 1;
	}
	@list = split(/\s*\,\s*/,$cache{'servers'});
	unless ($is_cache && $cache{'listservers'})
        {
	    my $str= &RFC::Main::report_client($listserver,'list_servers');
	    my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
	    foreach (@l)
	    {
		if (/([\w\.\-]+)/)
		{
		    push @listservers,$1;
		}
	    }
	    $cache{'listservers'} = join(',',@listservers);
	    $save_cache = 1;
	}
	@listservers = split(/\s*\,\s*/,$cache{'listservers'});
    }
    if (@listservers && @listservers > 1)
    {
	print h3("Avaliable listservers");
	print '<table border=0 cellspacing=10 cellpadding=0><tr>';
	foreach my $s (sort @listservers)
	{
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/main.cgi');
	    }
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    &print_hidden();
	    print submit(-name=>'dummy',-value=>$s,-class=>'s1',-id=>'list_'.$s);
#	    &menu_button('test',$s,'s1');
	    print end_form();
	    print '</td>';
		print <<END unless ($pwdhost eq 'localhost');
<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('list_'+'$s').value = res},cred);
</script>
END

	}
	print '</tr></table>';
    }
    if (@list)
    {
	print h3("Avaliable servers and rigs on listserver $listserver");
	print '<table border=0 cellspacing=10 cellpadding=0>';
	foreach my $s (sort @list)
	{
	    $s =~ /([\w\-\.]+)/;
	    $s = $1;
	    print '<tr>';
	    unless ($is_cache && $cache{$s.'_active_rigs'})
            {
		my $str = &RFC::Main::report_client($s,'active_rigs');
                $str = '' unless defined($str);
                $cache{$s.'_active_rigs'} = $str;
		$save_cache = 1;
            }
	    my $str = $cache{$s.'_active_rigs'};
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    my @l = ();
	    @l = split(/\t/,$str) if ($str);
	    my $rowspan=POSIX::floor(scalar(@l)/10)+1;
	    if ($isadmin)
	    {
		print "<td rowspan=$rowspan>";
		if (CGI::https())
		{
		    print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/confmanage.cgi');
		}
		else
		{
		    print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/confmanage.cgi');
		}
		&print_hidden();
		print submit(-name=>'dummy',-value=>'Configure '.$s,-class=>'s1',-id=>$s);
		print end_form();
		print '</td>';
		print '<td width=10>';
		print '</td>';
		print <<END unless ($pwdhost eq 'localhost');
<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('$s').value = 'Configure '+res},cred);
</script>
END

	    }
	    else
	    {
		print "<th id='$s' rowspan=$rowspan>";
		print $s;
		print ': </th>';
		print <<END unless ($pwdhost eq 'localhost');
<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('$s').innerHTML = res+ ': '},cred);
</script>
END

	    }
	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not get rig numbers from '$s'</th>";
		&errorlog($l[0]);
		next;
	    }
	    unless (@l)
	    {
		print "<th colspan=8>No rigs or no connection to $s</th>";
	    }
	    my $count = 0;
	    foreach my $r (sort {$a <=> $b} @l)
	    {
		next unless ($r && $r =~ /\d/);
                print '</tr><tr><td></td>' if ($count && $count%10 == 0);
                $count++;
		print '<td>';
		if ($s eq $server)
		{
		    print start_form(-action=>'/cgi-bin/celltest/rig_main.cgi');
		}
		else
		{
		    if (CGI::https())
		    {
			print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/rig_main.cgi');
		    }
		    else
		    {
			print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/rig_main.cgi');
		    }
		}
		&print_hidden();
		print hidden(-name=>'rig',-value=>$r,-force=>1);
		&menu_button('test',"Rig $r",'s0');
		print end_form();
		print '</td>';
	    }
	    print '</tr>';
	}
    }
    else
    {
        print h3({-class=>'Alert'},"Error: Could not get server list from from '$listserver', using local list only");
        print '<table border=0 cellspacing=10 cellpadding=10>';
        print '<tr><td colspan=10 class="heading">';
        print "Data on all test stations:";
        print '</td></tr><tr>';
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} @l)
        {
	    print '<td>';
	    print start_form(-action=>'/cgi-bin/celltest/rig_main.cgi');
	    &print_hidden();
	    print hidden(-name=>'rig',-value=>$r,-force=>1);
	    &menu_button('test',"Rig $r",'s0');
	    print end_form();
	    print '</td>';
        }
    }
    print '</table>';
    print p();
    print '<table border=0 cellspacing=10 cellpadding=10>';
    print '<tr><td colspan=10 class="heading">';
    print "Data on all test stations on listserver $listserver:";
    print '</td></tr>';
    if (@list)
    {
	foreach my $s (sort @list)
	{
	    $s =~ /([\w\-\.]+)/;
	    $s = $1;
	    print '<tr>';
            unless ($is_cache && $cache{$s.'_rigs'})
            {
		my $str = &RFC::Main::report_client($s,'rigs');
                $str = '' unless defined($str);
                $cache{$s.'_rigs'} = $str;
            }
            my @l = split(/\t/,$cache{$s.'_rigs'});
	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not get rig numbers from '$s'</th>";
		&errorlog($l[0]);
		print '</tr>';
		next;
	    }
	    unless (@l)
	    {
		print "<th colspan=8>No rigs or no connection to $s</th>";
	    }
	    my $count = 0;
	    foreach my $r (sort {$a <=> $b} @l)
	    {
		next unless ($r && $r =~ /\d/);
                print '</tr><tr>' if ($count && $count%10 == 0);
                $count++;
		print '<td>';
		my $urlstr = 'http://'.$s.'/cgi-bin/show_data.cgi?name='.&get_user().'&pass='.&get_pass().'&url=http://'.$s.'/rig'.$r.'/';
		$urlstr = 'https://'.$s.'/cgi-bin/show_data.cgi?name='.&get_user().'&pass='.&get_pass().'&url=http://'.$s.'/rig'.$r.'/' if (CGI::https());
		print button(-name=>'test',-value=>"Rig $r",-class=>'s0',-onclick=>"openInNewTab('$urlstr')");
		print end_form();
		print '</td>';
	    }
	    print '</tr>';
	}
    }
    else
    {
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} (@l))
        {
	    next unless ($r && $r =~ /\d/);
            print '<td>';
            print start_form(-action=>'/rig'.$r.'/',-method=>'GET');
            menu_button('test',"Rig $r",'s0');
            print end_form();
            print '</td>';
        }
    }
    print '</table>';
    print '</center>';
    eval {
        if (!$is_cache && %cache || $save_cache)
        {
            $conf->lock_ex();
            $conf->writeline('');
            foreach my $key (keys %cache)
            {
                $conf->append($key.'#'.$cache{$key});
            }
            chmod 0666,$file;
            $conf->lock_un();
        }
    };
    if ($@)
    {
        warn $@;
    }
    print <<END;

<script>

function openInNewTab(url) {
    var win = window.open(url, '_blank');
    win.focus();
}

</script>

END

}
