#!/usr/bin/perl -T
# $Id: misc_conf.cgi,v 1.21 2021/01/26 10:42:54 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################


use strict;
use warnings;
use CGI qw(:standard :netscape);
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use SemaforeFile;

my $acmode = get_cv('global','access_mode');
$acmode = 'celltest' unless ($acmode);
my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);

my $usermode = user_auth($acmode,'c');
$usermode = 1 if (RFC::RFCCGI::rig_mode());
my $modifymode = user_auth($acmode,'m');
$modifymode = rig_cert() if (RFC::RFCCGI::rig_mode());
if (RFC::RFCCGI::rig_mode())
{
    ####  Read and use mode deprecated after initialisation of rig authentification ####
    $usermode = 1;
}
####
unless (RFC::RFCCGI::rig_auth())
{
    $usermode = 0;
    $modifymode = 0;
}
unless ($modifymode)
{
    $modifymode = RFC::Main::passwd_client('isadmin',get_id());
}
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if ((login_ok()) && (RFC::RFCCGI::rig_auth()) && $usermode)
    {
        &print_header("Miscellaneous setup for rig ".$rig->name);
        print RFC_start_html(-title=>"Miscellaneous setup for ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'});
	print <<END;

<script language="javascript">

function myRFC_open(script,w,h,l,t,winref)
{
    var user = document.login_info.name.value;
    var pass = document.login_info.pass.value;
    var time = document.login_info.time.value;
    var rig = document.login_info.rig.value;
    var js = document.login_info.jscheck.value;
    var hidden = "?name="+user+"&pass="+pass+"&time="+time+"&rig="+rig+"&jscheck="+js
	var myWindow=window.open(script+hidden,winref,'width='+w+',height='+h+',left='+l+',top='+t);
    myWindow.location.href = script+hidden;
    if (!myWindow.opener)
        myWindow.opener = self;
    myWindow.focus();
}


</script>



END


        top_nav_bar_start;
	print '<td>';
	print button(-name=>'plot',-value=>'Plot values',-class=>'s5',-onclick=>"myRFC_open('plot_values.cgi',800,600,100,100,'plot')");
	print '</td>';
	top_nav_bar_button('','','','Miscellaneous setup','s1','rig,'.$rig->name.',1');
        if ($modifymode || $usermode)
        {
            top_nav_bar_button('','crontab','dummy','Rig '.$rig->name.' scheduler (crontab)','s5','rig,'.$rig->name.',1');
        }
        else
        {
            top_no_button;
        }
        tab_newrow;
	if (get_CGI_value('action') && get_CGI_value('action') =~ /update/i)
	{
	    top_no_button;
	}
	else
	{
	    &js_back();
	    top_js_return('#006600','white');	    
	}
        if ($modifymode)
        {
            top_nav_bar_button('rig_conf.cgi','','','Manual configuration','s1','rig,'.$rig->name.',1');
        }
        else
        {
            top_no_button;
        }
        if ($modifymode || $usermode)
        {
            top_nav_bar_button('rig_setup.cgi','','','Rig '.$rig->name.' configuration','s2','rig,'.$rig->name.',1');
        }
        else
        {
            top_no_button;
        }
        top_nav_bar_button('rig_main.cgi','','','To rig'.$rig->name.' main page','s3','rig,'.$rig->name.',1');
        top_nav_bar_button('main.cgi','','','To menu','s4');
        end_top_bar;
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
        $_ = param('action');
      CASE:
        {
            ### Insert case statements ###
	    /Update/ and do {&update_crontab;};
	    /crontab/ and do {&crontab; last CASE;};
            ### Default response ####
            &insert_data_form;
        }
        print_end;
    }
    else
    {
        &not_auth;
    }
}

exit;

sub crontab
{
    print '<center>';
    print h1('Crontab setup for rig '.$rig->name);
    my $crontab = RFC::Main::CGI_client($rig->name,'crontab_read');
    print start_form();
    print_hidden_rig();
    print textarea(-name=>'crontab',-value=>$crontab,-force=>1,-cols=>120,-rows=>20);
    print '<p>';
    print submit(-name=>'action',-value=>'Update crontab for rig '.$rig->name,-class=>'s3',-style=>'width:300px;');
    print end_form();
    print '</center>';
}


sub update_crontab()
{
    my $text = param('crontab');
    $text =~ s/[\r\n]+/\n/g;
    my $filename = $RFC::Header::publicdir.'rig'.$rig->name.'/crontab.txt';
    system("/usr/bin/co -l $filename") if (-e $filename.',v');
    my $file = SemaforeFile->new($filename);
    $file->writeline($text);
    system("echo '.' | /usr/bin/ci -u $filename");
    my $user = get_user();
    $rig->proglog("Crontab updated",$user);
    my $res = RFC::Main::CGI_client($rig->name,'crontab_file',$filename);
    if ($res && $res =~ /Crontab installed/)
    {
	print center(h2('Crontab updated'));
    }
    else
    {
	print center(h1({-class=>'Alert'},"Error: $res"));
    }
}

sub insert_data_form
{
    print '<center>';
    print '<table cellspacing=5 cellpadding=5 class="tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="15%"></td>';
    print '<td width="25%"></td>';
    print '<td width="5%"></td>';
    print '<td width="15%"></td>';
    print '<td width="25%"></td>';
    print '<td width="5%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    my @tags = ();
    my @yn = ('','Yes','No');
    my @auth = ('local','remote');
    foreach my $sec (split(/\s*\,\s*/,get_uicfg('misc','sections')))
    {
	my $heading = $sec;
	$heading =~ s/_/ /g;
	$heading =~s/(\w)(interface)/$1 $2/g;
	print '<tr><td height=20></td></tr>';
        print '<tr><td colspan=11 class="heading"> '.ucfirst(lc($heading)).' setup </td></tr>';
        my @cf = split(/\s*\,\s*/,get_uicfg('misc','keys_'.$sec));
        my %setup = ();
        foreach my $tag (@cf)
        {
            $setup{$tag} = $rig->get_cv($sec,$tag);
        }
        my $count = 0;
        foreach my $key (@cf)
        {
	    next if ($key eq 'status' && !$modifymode);
            print '<tr><td></td>' unless ($count);
            my @l = ();
            my $tag = $key;
	    if ($key eq 'logall')
	    {
		$tag = 'Log all';
		@l = @yn;
		if ($setup{$key} && $setup{$key} =~ /yes/i)
		{
		    $setup{$key} = 'Yes';
		}
		else
		{
		    $setup{$key} = 'No';
		}
	    }	    
	    if ($key eq 'status')
	    {
		@l = ('OK','Disabled');
		if ($setup{$key} && $setup{$key} =~ /Disabled/i)
		{
		    $setup{$key} = 'Disabled';
		}
		else
		{
		    $setup{$key} = 'OK';
		}
	    }
	    @l = @auth if ($key eq 'authorisation');
	    if ($key =~ /^additional/ && $key !~ 'additional_vogt_gasses')
	    {
		my $dir = $RFC::Header::libdir.'logprograms/';
		opendir MYDIR,$dir or die "Could not open dir $dir $!";
		@l = grep { (!/^\./) && -f "$dir$_"} readdir(MYDIR);
		unshift @l,'';
	    }
            print '<th>';
            $tag =~ s/_/ /g;
	    $tag =~ s/(\w)(range)/$1 $2/g;
            print xss(ucfirst($tag));
            print '</th><td>';
            if (@l>1)
            {
                print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$setup{$key},-force=>1,-onchange=>"change_val(this,'$sec')",-id=>$key);
            }
            else
            {
                print textfield(-name=>$key,-value=>$setup{$key},-class=>'textfield',-force=>1,-onchange=>"change_val(this,'$sec')",-id=>$key);
            }
            print '</th><th></th>';
            if ($count++ > 0)
            {
                $count = 0;
                print '</tr>',"\n";
            }
        }
    }
    print '</table>';
    print '</center>';
    print <<END;

<script language="javascript">

function stop_iv()
{
    var ok = confirm("Stop running iV curve?");
    if (ok)
    {
        run_ajax('rig_main.cgi','&action=stop_iv',set_temp_ok);
    }
}

function set_temp_ok(t)
{
    alert(t);
    /* Sumbit the login info to reset logout timer */
        document.login_info.submit();
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
        if (arr[0] == "WARN")
        {
            alert(arr[3]);
        }
        var obj = document.getElementById(arr[1]);
        obj.disabled = false;
        obj.value = arr[2];
    }
    else
    {
        alert(arr[0]);
    }
}

function change_val(element,section)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    run_ajax('change_config.cgi','&action=change_config_value&section='+section+'&key='+n+'&value='+val,set_val);
}

</script>

END



}
