#!/usr/bin/perl -T
#$Id: show_data.cgi,v 1.20 2021/03/25 08:52:12 sqko Exp $
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use CGI qw(:standard :netscape);
use Sys::Hostname;
use LWP::Simple qw(get);
my $hostname = hostname();
my ($u,$p) = &RFC::RFCCGI::get_id();
unless ($u)
{
    print header("Data gateway for $hostname");
    print start_html("Data gateway for $hostname");
    print '<link rel="stylesheet" type="text/css" href="/celltest/RFCcontrol.css" />',"\n";
    print '<center>';
    print h2('<class="login_title">The requested data requires login for access:');
    print start_form(-action=>'/cgi-bin/show_data.cgi');
    print '<div>',"\n";
    print h2('Please log in</>');
    print '<div class="username_login" style="margin-left: 6px;">';
    print '<lable class="username_lable" style="font-size: 1.25em;">Username</lable>';
    print br;
    print textfield(-name=>'name',-value=>'',-placeholder=>'Please enter username',-force=>1,-style=>'width:15em; height: 2.5em');
    print br;
    print "</div>";
    print '<div class="password_login" style="margin-left: 6px;">';
    print '<lable class="password_lable" style="font-size: 1.25em;">Password</lable>';
    print br;
    print password_field(-name=>'pass',-autofocus=>'',-value=>'',-placeholder=>'Please enter password',-force=>1,-style=>'width:15em; height: 2.5em');
    print "</div>";
    print '<div class="button_login" style="margin-left: 6px; margin-top: 6px;">';
    print submit(-name=>'action',-value=>'Login',-class=>'Login');
    print '</div>';
    print '</div>';
    print hidden(-name=>'url');
    print hidden(-name=>'rig');
    print hidden(-name=>'test');
    print end_form();
    print '</center>';
    print end_html;
    exit;
}

if (param('action') && param('action') eq 'Login')
{
    $p = &RFC::Main::passwd_client('new_session',$u,$p);
    param(-name=>'pass',-value=>$p);
}


my $allow = 0;
my $uid = 0;
my @authids = &get_cv('global','data_access_authorisationid');
if (@authids)
{
    $uid = RFC::RFCCGI::login_ok();
    if ($uid)
    {
	foreach my $id (@authids)
	{
	    ## Allow is user is authorised for at least one of the listed authorisations
	    next if ($allow);
            eval {
                $allow = SocketClient::socket_client('localhost',4042,'get_auth',$u,$id);
            };
            if ($@)
            {
                ## Ignore if auth cache server is not running ##
            }
            next if ($allow);
	    $allow = &RFC::Main::passwd_client('safety_auth',$u,$id);
	    eval {
		SocketClient::socket_client('localhost',4042,'set_auth',$u,$id,$allow);
            };
            if ($@)
            {
                ## Ignore if auth cache server is not running ##
            }
	}
    }
    else
    {
	$allow = 0;
    }    
}
else
{
    $allow = 1;
}

my $doc_root = '/home/http/html/';

my $url = param('url');
if (param('rig'))
{
    $url = 'http://'.$hostname.'/rig'.param('rig').'/';
}
$url = 'http://'.$hostname unless ($url);
my $r = '';
if ($url && $url =~ /\/(\d+)test(\d+)\//)
{
    $r = $1;
    my $t = $2;
    my $dir = $doc_root.'rig'.$r.'/'.$r.'test'.$t.'/';
    my $f = $dir.'.restrict';
    if (-e $f)
    {
	open MYIN,'<',$f or die "Could not open file $f: $!\n";
	my @lines = <MYIN>;
	close MYIN;
	foreach my $l (@lines)
	{
	    next if ($l && $l =~ /^[\s\t]*#/);
	    next unless ($l && $l =~ /allow\s+\=\s+([\s\d\,]+)/);
	    my $auth = $1;
	    my @list = ();
	    @list = split(/\s*\,\s*/,$auth);
	    @authids = @list;
	    if (@list)
	    {
		$allow = 0;
		foreach my $id (@list)
		{
		    ## Allow is user is authorised for at least one of the listed authorisations
		    next if ($allow);
		    $allow = &RFC::Main::passwd_client('safety_auth',$u,$id);
		}
	    }
	    last;
	}
    }
}

unless ($allow)
{
    print header("Data gateway for $hostname");
    print start_html("Data gateway for $hostname");
    print '<link rel="stylesheet" type="text/css" href="/celltest/RFCcontrol.css" />',"\n";
    print center(h1('Warning: You are not allowed to access data on this server!'));
    if ($uid)
    {
	print center(h1("You likely need authroisation for one of the following authorisations: ".join(', ',@authids)));
    }
    else
    {
	print center(h1('Possibly your session has timed out'));
    }   
    print start_form(-action=>'/cgi-bin/show_data.cgi');
    print hidden(-name=>'url',-value=>$url,-force=>1);
    print center(submit(-name=>'dummy',-value=>'To login page',-class=>'Login'));
    print end_form();
    print end_html();
    exit;
}


my $baseurl = $url;
$baseurl =~ s/[\w\.\-\:]+$//;
my $html = get $url;

if ($url=~ /\.pdf$/i)
{
    my $length = length($html);
    print "Content-type: application/pdf\n";
    if ($url =~/([\w\-]+\.pdf)$/)
    {
        print "Content-Disposition: inline; filename=$1\n";
    }
    print "Content-length: $length \n\n";
    print $html;
    exit;
}
if ($url=~ /\.ps$|\.eps$/i)
{
    my $length = length($html);
    print "Content-type: application/postscript\n";
    if ($url =~/([\w\-]+\.\w+)$/)
    {
        print "Content-Disposition: inline; filename=$1\n";
    }
    print "Content-length: $length \n\n";
    print $html;
    exit;
}
if ($url=~ /\.png$|\.jpg$/i)
{
    my $length = length($html);
    print "Content-type: image/gif\n";
    if ($url =~/([\w\-]+\.\w+)$/)
    {
        print "Content-Disposition: inline; filename=$1\n";
    }
    print "Content-length: $length \n\n";
    print $html;
    exit;
}


my $base = 'cgi-bin/show_data.cgi?name='.$u.'&pass='.$p.'&url=';
my $baseimg = 'cgi-bin/show_img.cgi?name='.$u.'&pass='.$p.'&url=';
$html =~ s/(\<a\s+href)/\n$1/g;
$html =~ s/(\<img)/\n$1/g;
my @lines = split(/\n/,$html);

if ($url =~ /configfile|proglog|errorlog|raadata|jdata|numbers|\.txt|\.gp|tabel$|\.i2b|\.conf|\/\w+$/i)
{
    print header(-type=>'text');
}
else
{
    print header();
}

foreach my $line (@lines)
{
    if ($line =~/name="name" value=""/)
    {
	$line =~ s/name="name" value=""/name="name" value="$u"/g;
    }
    if ($line =~/name="pass" value=""/)
    {
	$line =~ s/name="pass" value=""/name="pass" value="$p"/g;
    }
    if ($line =~ /^<a href="([\w\.\:\-\/]+)\s*"\s*>/)
    {
	my $link = $1;
	if ($link =~ /http/)
	{
	    
	}
	else
	{
	    $link = '/'.$base.$baseurl.$link;
	}
	$line =~ s/^<a href="([\w\.\:\-\/]+)\s*"\s*>/<a href="$link">/;
    }
    if ($line =~ /^<img\s+src="([\w\.\-\:\/]+)"/ && $line !~ /icons/)
    {
	my $link = $1;
	$link = '/'.$baseimg.$baseurl.$link;
	$line =~ s/^<img\s+src="[\w\.\-\:\/]+"/<img src="$link"/;
    }
    print $line,"\n";
}
