#!/usr/bin/perl -T
#$Id: show_img.cgi,v 1.10 2021/03/18 13:05:43 sqko Exp $
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use CGI qw(:standard :netscape);
use Sys::Hostname;
use LWP::Simple qw(get);
use SocketClient;
my $hostname = hostname();
my $u = &RFC::RFCCGI::get_user();
my $p = &RFC::RFCCGI::get_pass();
my $allow = 0;
my @authids = &get_cv('global','data_access_authorisationid');
if (@authids)
{
    my $uid = RFC::RFCCGI::login_ok();
    if ($uid)
    {
        foreach my $id (@authids)
        {
            ## Allow is user is authorised for at least one of the listed authorisations                                                                                                    
            next if ($allow);
	    eval {
                $allow = SocketClient::socket_client('localhost',4042,'get_auth',$u,$id);
            };
            if ($@)
            {
                ## Ignore if auth cache server is not running ##
            }
            next if ($allow);
            $allow = &RFC::Main::passwd_client('safety_auth',$u,$id);
	    eval {
		SocketClient::socket_client('localhost',4042,'set_auth',$u,$id,$allow);
	    };
	    if ($@)
	    {
		## Ignore if auth cache server is not running ##
	    }    
        }
    }
    else
    {
        $allow = 0;
    }
}
else
{
    $allow = 1;
}

my $doc_root = '/home/http/html/';

my $url = param('url');

if ($url && $url =~ /\/(\d+)test(\d+)\//)
{
    my $r = $1;
    my $t = $2;
    my $dir = $doc_root.'rig'.$r.'/'.$r.'test'.$t.'/';
    my $f = $dir.'.restrict';
    if (-e $f)
    {
        open MYIN,'<',$f or die "Could not open file $f: $!\n";
        my @lines = <MYIN>;
        close MYIN;
        foreach my $l (@lines)
        {
            next if ($l && $l =~ /^[\s\t]*#/);
	    next unless ($l && $l =~ /allow\s+\=\s+([\s\d\,]+)/);
	    my $auth = $1;
	    my @list = ();
	    @list = split(/\s*\,\s*/,$auth);
            if (@list)
	    {
		$allow = 0;
		foreach my $id (@list)
		{
		    ## Allow is user is authorised for at least one of the listed authorisations
		    next if ($allow);
		    $allow = &RFC::Main::passwd_client('safety_auth',$u,$id);
		}
	    }
	    last;
	}
    }
}

unless ($allow)
{
    print header("Data gateway for $hostname");
    print start_html("Data gateway for $hostname");
    print center(h1('Warning: You are not allowed to access data on this server!'));
    print end_html();
    exit;
}

my $html = get $url;
my $length = length($html);
print "Content-type: image/gif\n";
print "Content-length: $length \n\n";
print $html;
exit;
